/*
 * The is example is being used it demonstrate inheritance. This will be
 * the parent class which stores a location in GPS coordinates.
 * It is not an abstract class because one might want an instance of  this class
 * that is not an instance of a subclass.
 */
public class Location {


	   protected double latitude, longitude; // GPS coordinates of the location
	   String name;

	   // no-argument constructor
	   public Location()
	   {
		   latitude = 0;
		   longitude = 0;
		   name = "";
		   System.out.println( "Point constructor: " + this );
	   }

	   // constructor
	   public Location ( String name, double latitude, double longitude )
	   {
		   // verify that the latitude and longitude are within proper range.
		   if ( latitude < -90 || latitude > 90 || longitude < -180 || longitude > 180 )
			   throw new IllegalArgumentException("Coordinate out of range.");

	      this.latitude = latitude;
	      this.longitude = longitude;
	      this.name = name;

	      System.out.println( "Location constructor.");
	   }

	   // convert the point into a String representation
	   public String toString()
	   {
		   	String gps;
		   	double printLong = longitude;
		   	double printLat = latitude;

		   	gps = name + ": ";

		   	// instead of using negative numbers of west of the prime meridian
		   	// we use W and E.
		   	if ( longitude < 0 )
		   	{
		   		gps += "W ";
		   		printLong = -longitude;
		   	}
		   	else
		   		gps += "E ";

		   	gps += printLong;

		   	// use S and N instead of negative numbers to denote locations
		   	// south of the equator
		   	if ( latitude < 0 )
		   	{
		   		gps += " S ";
		   		printLat = -latitude;
		   	}
		   	else
		   		gps += " N ";

		   	gps += printLat;

		   	return gps;
	   }

	   // This method computes the distance in meters between this location
	   // and the location specified by the input latitude and longitude.
	   public double distanceInMeters( Location loc )
	   {
		   double lat1 = loc.latitude;
		   double lng1 = loc.longitude;
		   double lat2 = latitude;
		   double lng2 = longitude;

		   double earthRadius = 3958.75;
		   double dLat = Math.toRadians(lat2-lat1);
		   double dLng = Math.toRadians(lng2-lng1);
		   double a = Math.sin(dLat/2) * Math.sin(dLat/2) +
		   		Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2)) *
		   		Math.sin(dLng/2) * Math.sin(dLng/2);

		   double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
		   double dist = earthRadius * c;

		   int meterConversion = 1609;

		   return ( dist * meterConversion );
	   }
}
